transformers-0.3.0.0: Concrete functor and monad transformers

Copyright | (c) The University of Glasgow 2001
License | BSD-style (see the file LICENSE)
Maintainer | ross@soi.city.ac.uk
Stability | experimental
Portability | portable
Safe Haskell | Safe-Inferred
Language | Haskell98

Control.Monad.Trans.Cont

Contents

- The Cont monad
- The ContT monad transformer
- Lifting other operations

Description

Continuation monads.

Synopsis

- type Cont r = ContT r Identity
- cont :: ((a -> r) -> r) -> Cont r a
- runCont :: Cont r a -> (a -> r) -> r
- mapCont :: (r -> r) -> Cont r a -> Cont r a
- withCont :: ((b -> r) -> a -> r) -> Cont r a -> Cont r b
- newtype ContT r m a = ContT {
  - runContT :: (a -> m r) -> m r
  }
- mapContT :: (m r -> m r) -> ContT r m a -> ContT r m a
- withContT :: ((b -> m r) -> a -> m r) -> ContT r m a -> ContT r m b
- callCC :: ((a -> ContT r m b) -> ContT r m a) -> ContT r m a
- liftLocal :: Monad m => m r' -> ((r' -> r') -> m r -> m r) -> (r' -> r') -> ContT r m a -> ContT r m a

# The Cont monad

type Cont r = ContT r Identity

Continuation monad. `Cont r a` is a CPS computation that produces an intermediate result of type `a` within a CPS computation whose final result type is `r`.

The `return` function simply creates a continuation which passes the value on.

The `>>=` operator adds the bound function into the continuation chain.

cont :: ((a -> r) -> r) -> Cont r a

Construct a continuation-passing computation from a function. (The inverse of `runCont`.)

runCont

Arguments

:: Cont r a | continuation computation (`Cont`).
-> (a -> r) | the final continuation, which produces the final result (often `id`).
-> r |

Runs a CPS computation, returns its result after applying the final continuation to it. (The inverse of `cont`.)

mapCont :: (r -> r) -> Cont r a -> Cont r a

Apply a function to transform the result of a continuation-passing computation.

-     runCont (mapCont f m) = f . runCont m

withCont :: ((b -> r) -> a -> r) -> Cont r a -> Cont r b

Apply a function to transform the continuation passed to a CPS computation.

-     runCont (withCont f m) = runCont m . f

# The ContT monad transformer

newtype ContT r m a

The continuation monad transformer. Can be used to add continuation handling to other monads.

Constructors

ContT |

Fields

runContT :: (a -> m r) -> m r

Instances

MonadTrans (ContT r) |
Monad (ContT r m) |
Functor (ContT r m) |
Applicative (ContT r m) |
MonadIO m => MonadIO (ContT r m) |

mapContT :: (m r -> m r) -> ContT r m a -> ContT r m a

Apply a function to transform the result of a continuation-passing computation.

-     runContT (mapContT f m) = f . runContT m

withContT :: ((b -> m r) -> a -> m r) -> ContT r m a -> ContT r m b

Apply a function to transform the continuation passed to a CPS computation.

-     runContT (withContT f m) = runContT m . f

callCC :: ((a -> ContT r m b) -> ContT r m a) -> ContT r m a

`callCC` (call-with-current-continuation) calls its argument function, passing it the current continuation. It provides an escape continuation mechanism for use with continuation monads. Escape continuations one allow to abort the current computation and return a value immediately. They achieve a similar effect to `throwError` and `catchError` within an `ErrorT` monad. The advantage of this function over calling `return` is that it makes the continuation explicit, allowing more flexibility and better control.

The standard idiom used with `callCC` is to provide a lambda-expression to name the continuation. Then calling the named continuation anywhere within its scope will escape from the computation, even if it is many layers deep within nested computations.

# Lifting other operations

liftLocal :: Monad m => m r' -> ((r' -> r') -> m r -> m r) -> (r' -> r') -> ContT r m a -> ContT r m a

``liftLocal` ask local` yields a `local` function for ``ContT` r m`.